datablock fxDTSBrickData (BrickV8Zombie_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/4xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "V8Zombie Hole";
	iconName = "Add-Ons/Bot_V8Zombie/icon_Zombie";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "V8ZombieHoleBot";
};

datablock PlayerData(V8ZombieHoleBot : PlayerStandardArmor)
{
	uiName = "";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 0;
	maxWeapons = 0;
	maxTools = 0;
	runforce = 100 * 90;
	maxForwardSpeed = 4;
	maxBackwardSpeed = 2;
	maxSideSpeed = 2;
	attackpower = 10;
	rideable = false;
	canRide = false;
	maxdamage = 200;//Health
	jumpSound = "";
	
	//Hole Attributes
	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 64;//above range, set in brick units

	hType = V8Zombie; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100;
	//can have unique types, nazis will attack V8Zombies but nazis will not attack other bots labeled nazi
	hName = "V8Zombie";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 1024;//Defines the distance bot can travel away from spawnbrick
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = -2;//in brick units
	  hSight = 0;//Require bot to see player before pursuing
	  hStrafe = 1;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRadius = 32;//max 10

	  hAlertOtherBots = 1;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 15;//15;//Melee Damage
	hShoot = 0;
	  hWep = "gunImage";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 30;//The range in which the bot will shoot the player
	  hAvoidCloseRange = 1;//
		hTooCloseRange = 7;//in brick units
	//hHerding = 0;
	//hSound = 1;
	//hSpawnDetect = -1;//Will not spawn when user is too close and can see spawn
	

	
	//Misc options
	hAvoidObstacles = 1;
	hSuperStacker = 1;
	hSpazJump = 0;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things
	hIdle = 0;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 1;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;
	
	hCustomLoop = 0;//Will call dataBlock::hOnLoop every tick
	hCustomCollision = 1;//Will call dataBlock::hOnCollision when bot collides with another object
	hCustomFollow = 0;//Will call dataBlock::hOnFollow when bot follows another player/bot
};

function V8ZombieHoleBot::onAdd( %this, %obj )
{
	armor::onAdd(%this,%obj);
	
	%obj.playthread(1,"ArmReadyBoth");
	%obj.hDefaultThread = "ArmReadyBoth";
	//Appearance V8Zombie
	%obj.llegColor =  "0 0.141 0.333 1";
	%obj.secondPackColor =  "0 0.435 0.831 1";
	%obj.lhand =  "0";
	%obj.hip =  "0";
	%obj.faceName =  "asciiTerror";
	%obj.rarmColor =  "0.593 0 0 1";
	%obj.hatColor =  "1 1 1 1";
	%obj.hipColor =  "0 0.141 0.333 1";
	%obj.chest =  "0";
	%obj.rarm =  "0";
	%obj.packColor =  "0.2 0 0.8 1";
	%obj.pack =  "0";
	%obj.decalName =  "AAA-None";
	%obj.larmColor =  "0.593 0 0 1";
	%obj.secondPack =  "0";
	%obj.larm =  "0";
	%obj.chestColor =  "0.75 0.75 0.75 1";
	%obj.accentColor =  "0.990 0.960 0 0.700";
	%obj.rhandColor =  "0.626 0.71 0.453 1";
	%obj.rleg =  "0";
	%obj.rlegColor =  "0 0.141 0.333 1";
	%obj.accent =  "1";
	%obj.headColor =  "0.626 0.71 0.453 1";
	%obj.rhand =  "0";
	%obj.lleg =  "0";
	%obj.lhandColor =  "0.626 0.71 0.453 1";
	%obj.hat =  "0";

	GameConnection::ApplyBodyParts(%obj);
	GameConnection::ApplyBodyColors(%obj);
	
	%owner = %obj.spawnBrick.getGroup().client;
		
	if( !%owner.isAdmin && !%owner.isSuperAdmin )
	{
		%owner.centerPrint( "<color:FFFF00>V8Zombies will only break bricks if you're admin.", 5);
	}
}

function V8ZombieHoleBot::onBotLoop(%this,%obj)
{
	// make sure they're in a minigame
	if( !isObject( getMiniGameFromObject( %obj ) ) )
		return;

	%owner = %obj.spawnBrick.getGroup().client;
		
	// make sure our owner is an admin
	if( %owner.isAdmin || %owner.isSuperAdmin )
	{
		V8ZombieBreak(%obj);
		schedule(%obj.getDatablock().hTickRate/2,0,V8ZombieBreak,%obj);
	}
}

function V8ZombieHoleBot::onBotFollow( %this, %obj, %targ )
{
	%pos1 = %obj.getPosition();
	%pos2 = %targ.getPosition();
	
	// echo( "Enaged @" SPC vectorDist( %pos1, %pos2 )*2 );
	// %obj.kill();
}

function V8ZombieHoleBot::onBotCollision(%this, %obj, %col, %a, %b)
{
	//Called once every second the object is colliding with something
	//Turn the enemy bot into a V8Zombie if his health is low
	// return;
}

function V8ZombieCheckBreakable( %obj )
{
	%data = %obj.getDataBlock();
	
	%indestructable = %data.indestructable;
	%volume = %data.getVolume();
	%upBricks = %obj.getNumUpBricks();
	
	if( %indestructable )
		return 0;
	
	if( %volume > 3000 )
		return 0;
		
	return 1;
}

function V8ZombieBreak(%obj)
{
	if( !isObject( %obj ) )
		return;

	%mask = $TypeMasks::FxBrickObjectType;
	%ranZ = getrandom(0,1) @ "." @ getrandom(0,9);
	%startPos = vectoradd(vectoradd(%obj.getEyePoint(),"0 0 1"),"0 0" SPC -%ranZ);
	if(isObject(%obj))
	{
		%eyePoint = %obj.getEyePoint();
		%eyeVec = %obj.getEyeVector();
		%pos = %obj.getPosition();
		if(isObject(%obj.hFollowing))
		{
			%playerPos = %obj.hFollowing.getPosition();
		}
	}
	else return;

	%target = ContainerRayCast(%startPos, vectorAdd(vectorScale(%eyeVec,3),%eyePoint), %mask,%obj);

	if(%target)
	{
		if( V8ZombieCheckBreakable( %target ) )
		{
			%anim = 1;
			%obj.playthread(2,activate2);
			%target = %target.getID();
			%target.killBrick();
		}
	}

	%mask = $TypeMasks::FxBrickObjectType;

	%target = ContainerRayCast(%eyePoint, vectorAdd(%eyePoint,"0 0 2"), %mask,%obj);

	if(%target)
	{
		if( V8ZombieCheckBreakable( %target ) )
		{
			if(%anim != 1)
			{
				%anim = 1;
				%obj.playthread(2,activate2);
			}

			%target = %target.getID();
			%target.killBrick();
		}
	}

		%mask = $TypeMasks::FxBrickObjectType;

	%target = ContainerRayCast(%eyePoint, vectorAdd(%eyePoint,"0 0 -10"), %mask,%obj);

	if(%target)
	{
		if(%target.getDatablock().indestructable != 1 &&  isObject(%obj.hFollowing) && getword(%pos ,2) > getword(%obj.hFollowing.getPosition(),2)+5  && %target.getDatablock().getVolume() < 1024)
		{
			if(%anim != 1)
			{
				%obj.playthread(2,activate2);
			}

			%target = %target.getID();
			%target.killBrick();
		}
	}
}